/*
 * XATICABus.h
 *
 *  Created on: 6.4.2010
 *      Author: matej
 */

#ifndef XATICABUS_H_
#define XATICABUS_H_

#define XATICA_BUS_DEFAULT_SIZE 	100

typedef struct tXATICAMessageBusEntry {
	char *message;
	long ticket;
} XATICAMessageBusEntry;

typedef struct tXATICAMessageBus {
	int top;
	int bottom;
	int length;
	XATICAMessageBusEntry **entries;
} XATICAMessageBus;

/**
 * Initialise the bus with the given size. The structure must be allocated,
 * but the fields should be undefined or null.
 */
int XATICABusInit(XATICAMessageBus *bus, int size);

/**
 * Free the contents of the message bus. The caller should still free the
 * structure, however.
 */
int XATICABusFree(XATICAMessageBus *bus);

/**
 * Free the contents of the message bus entry. The caller should free the
 * structure itself.
 */
int XATICABusEntryFree(XATICAMessageBusEntry *entry);

/*
 * Resize (grow or shrink) the message bus.
 */
int XATICABusResize(XATICAMessageBus *bus, int newSize);

/*
 * Add a message entry to the message bus to the end of the queue.
 */
int XATICABusAddMessage(XATICAMessageBus *bus, XATICAMessageBusEntry *entry);

/*
 * Get the next message from the queue. Returns null if the queue is empty.
 */
XATICAMessageBusEntry *XATICABusGetNextMessage(XATICAMessageBus *bus);

#endif /* XATICABUS_H_ */
