#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * Adds archive rule. Auditing will archive the data described in the
	 * monitoring rule.
	 * 
	 * @param monRule
	 *            Notification type of monitoring rule.
	 * @param userCrt
	 *            User certificate.
	 */

int addArchiveRuleXATI(const char* __monRule,const char* __userCrt, char** returnValue);


	/**
	 * Adds timed archive rule. Auditing will archive the data described in the
	 * monitoring rule in timed intervals.
	 * 
	 * @param monRule
	 *            Query type of monitoring rule.
	 * @param userCrt
	 *            User certificate.
	 */

int addTimedArchiveRule(const char* __monRule,int __period,const char* __userCrt, char** returnValue);


	/**
	 * Cancels archive rule.
	 * 
	 * @param archiveRuleId
	 *            Archive rule ID.
	 * @param userCrt
	 *            User certificate
	 * @throws Exception
	 */

int cancelArchiveRule(const char* __archiveRuleId,const char* __userCrt );



/* TODO
 * Unimplemented return type: java.util.ArrayList
 */
int queryXATI(const char* __query,const char* __userCrt, void* returnValue);


	/**
	 *	Gets a list of archive rule id, monitoring rule pairs. 
	 * 
	 * @param userCrt User certificate.
	 * @return List of archiving rules.
	 */
/* TODO
 * Unimplemented return type: java.util.HashMap<java.lang.String, java.lang.String>
 */
int getArchivingRulesXATI(const char* __userCrt, void* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
