#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/************************ CHECKPOINT *****************************/
	/** select on each grid node kernel checkpointer bound to node, no job-unit checkpointer matching yet!!
	 * @author John Mehnert-Spahn & Eugen Feller
	 * @param kernel checkpointer Id
	 */ 

int selectCheckpointer(const char* __initialJobId,const char* __jobId,int __jobUnitId,const char* __jsdlFile,const char* __executable,int __kernelCheckpointerId,const char* __preferredKernelCheckpointer,const CommunicationAddress __jobUnitCpAddr,const CommunicationAddress __jobCpAddr,const CommunicationAddress __superJobCpAddr,const char* __lastCheckpointVersion,const char* __strategy,const char* __options,const char* __mode,const ArrayList __dependentJobs,const char* __userCert, int* returnValue);




int prepareJobUnit(const char* __jobId,const char* __initialJobId,const char* __jsdlFile,const char* __jobUnitID,const ArrayList __dependentJobs,const char* __executable,const CommunicationAddress __jobCpAddr,const CommunicationAddress __superJobCpAddr,const char* __processList,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __kernelCheckpointer,const char* __pidCGroupName,const char* __strategy,const char* __options,const char* __mode,const char* __userCert,const char* __containerId,const char* __serverPort, int* returnValue);


	/**
	 * @author John Mehnert-Spahn & Eugen Feller
	 * @param jobId
	 * @annotation: merge CRExecMng and ExecMng to avoid exchange overhead!
	 */ 	

int stopJobUnit(const char* __jobId,const char* __initialJobId,const char* __jobUnitId,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __pidCGroupName,const char* __processList,const char* __executable,const char* __cpImageVersion,const CommunicationAddress __jcAddr,const char* __containerId, int* returnValue);


	/**
	 * @author John Mehnert-Spahn & Eugen Feller
	 * @param 
	 * @annotation: merge CRExecMng and ExecMng to avoid exchange overhead!
	 */ 

int checkpointJobUnit(const char* __jobId,const char* __initialJobId,const char* __jobUnitId,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __pidCGroupName,const char* __processList,const char* __executable,const char* __options,const char* __cpImageVersion,const char* __checkpointPath,const CommunicationAddress __jobCpAddr,const char* __containerId, int* returnValue);




int resumeJobUnitCP(const char* __jobId,const char* __initialJobId,const char* __jobUnitId,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __pidCGroupName,const char* __processList,const char* __executableName,const char* __cpImageVersion,const CommunicationAddress __jobCpAddr,const char* __containerId, int* returnValue);


	/*********** RESTART *********************/
	/** 
	 * @author John Mehnert-Spahn & Eugen Feller
	 */

int continueRebuildJobUnit(const char* __jobId,const char* __jobUnitId,const char* __initialJobId,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __pidCGroupName,const char* __checkpointVersion,const char* __kernelCheckpointer,const char* __jsdlFile,const char* __input,const char* __output,const char* __cmd,const char* __error,const char* __userCert,const CommunicationAddress __jobCpAddr,const char* __containerId,const char* __serverPort );


	/**
	 * @author John Mehnert-Spahn & Eugen Feller
	 * @param cpImageVersion
	 * @param cpImageIdentifier - provide kernel checkpointer to rebuild (file path to image, image name, ...)
	 */

int resumeJobUnitRST(const char* __jobId,const char* __initialJobId,const char* __checkpointVersion,const char* __jobUnitId,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __pidCGroupName,const char* __processList,const CommunicationAddress __jobCpAddr,const char* __userCert,const char* __containerId );


	/** Application-initiated job-unit checkpoint (uncoordinated [with/without message logging] )
	*	create job-unit checkpoint meta data 	/xtreemfs/job_checkpoint_meta_data/JobId/JobUnit_x/VERSION/*.xml
	*   create job checkpoint meta-data		 	/xtreemfs/job_checkpoint_meta_data/JobId/JobId.txt 
	*   	ATTENTION: 	in uncoordinated cp job-checkpoint- meta-data MUST BE CREATED HERE (in coordinated cp it is created by the job checkpointer]
	*   				job checkpoint meta data keep track of the latest version of all job-unit checkpoint checkpoint images
	*   				e.g. Job1_Jobunit1:ImageVersion1_Jobunit2:ImageVersion1   =>both units have been cp-ed
	*   					 Job1_Jobunit1:ImageVersion2_Jobunit2:ImageVersion1   =>only JobUnit1 has been cp-ed
	*
	* 	Execute prepare, stop, checkpoint, resume in one run
	**/	

int appInitiatedJobUnitCheckpoint(const char* __jobId,const char* __jobUnitId,const char* __processList,const char* __jsdlFile,const char* __executable,const char* __output,const char* __error,const char* __input,const char* __options,const char* __cp_prot,const char* __server,int __cpIndex,const char* __userCert, int* returnValue);




int enableProcessPageFaultMonitoring(int __pid, int* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
