#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * Return the information of the jobs running in this resource
	 * 
	 * @return String with the information of the running jobs
	 */

int getJobsInfoByResource(const CommunicationAddress __resource,const char* __certificate, char** returnValue);


	/**
	 * Return the information of the jobs running in this resource Certificate
	 * is checked by jobMng on a job basis.
	 * 
	 * @return String with the information of the running jobs
	 */

int getJobsInfoResource(const char* __certificate, char** returnValue);


	/**
	 * Eugen adds code for correct job rebuilding at restart time.
	 * 
	 * @param jobId
	 * @param jobMngAddr
	 */

int rebuildJobUnit(const char* __jobId,const char* __initialJobId,int __jobUnitId,const char* __checkpointVersion,const CommunicationAddress __jobMngAddr,const char* __processGroupReferenceId,const char* __processGroupReferenceType,const char* __pidCGroupName,const char* __kernelCheckpointer,const char* __cpStrategy,const char* __jsdlFile,const char* __input,const char* __output,const char* __cmd,const char* __error,const char* __userCert,const char* __checkpointer,const char* __containerId,const char* __serverPort );




int assignProcessesToJobAtRestart(const char* __jobId,const char* __procListString );




int assignContainerToJobAtRestart(const char* __jobId,const char* __containerId,const char* __serverPort,const char* __masterPid );


	/**
	 * Retunr the JobId of the calling process (identified by its pid)
	 * 
	 * @param pid
	 *            of the calling process
	 * 
	 * @return String containg the jobId
	 */

int getJobSelf(int __pid, char** returnValue);


#ifdef __cplusplus 
 } 
 #endif 
