#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * Performs query that is based on monitoring rule.
	 * 
	 * @param monRule
	 *            Monitoring rule describing what to query.
	 * @param userCrt
	 *            User certificate.
	 * @return Query result. Type of the result depends on the monitoring rule.
	 * @throws Exception
	 */
/* TODO
 * Unimplemented return type: eu.xtreemos.xosd.monmng.metric.MetricValue
 */
int query(const char* __monRule,const char* __userCrt, void* returnValue);


	/**
	 * Performs query based on monitoring rule in specified intervals.
	 * 
	 * @param monRule
	 *            Monitoring rule describing what to query.
	 * @param period
	 *            Delay between queries in milliseconds.
	 * @param callback
	 *            Callback triggered containing query result.
	 * @param userCrt
	 *            User certificate.
	 * @return Returns timed query ID which is used for possible later
	 *         cancellation.
	 * @throws Exception
	 */

int addTimedNotification(const char* __monRule,int __period,const char* __monRuleName,const char* __userCrt );




int addNotificationXATI(const char* __monRule,const char* __monRuleName,const char* __userCrt );




int existsMonRuleNameXATI(const char* __monRuleName,const char* __userCrt, char* returnValue);


	/**
	 * Cancels monitoring rule.
	 * 
	 * @param monRuleName monitoring rule name.
	 * @param userCrt user certificate.
	 * @throws MonMngException
	 */

int cancelNotification(const char* __monRuleName,const char* __userCrt );




int subscribeXATI(const char* __monRuleName,const char* __callback,const char* __userCrt, char** returnValue);




int unsubscribeXATI(const char* __subscriptionId,const char* __userCrt );


	/**
	 * Gets all monitoring rules.
	 * 
	 * @param userCrt User certificate.
	 * @return Returns monitoring rule name, monitoring rule pairs.
	 */
/* TODO
 * Unimplemented return type: java.util.HashMap<java.lang.String, java.lang.String>
 */
int getMonitoringRulesXATI(const char* __userCrt, void* returnValue);




int saveEventXATI(const char* __event,const char* __userCrt );




int saveFloatMetricXATI(const char* __floatMetric,const char* __userCrt );




int saveDoubleMetricXATI(const char* __doubleMetric,const char* __userCrt );




int saveIntegerMetricXATI(const char* __integerMetric,const char* __userCrt );




int saveLongMetricXATI(const char* __longMetric,const char* __userCrt );




int saveStringMetricXATI(const char* __stringMetric,const char* __userCrt );


#ifdef __cplusplus 
 } 
 #endif 
