#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif

/* TODO
 * Unimplemented return type: java.lang.Object
 */
int getAllResources( void* returnValue);


	/**
	 * Creates a reservation with a given request. Returns new reservation id,
	 * if the reservation succeeds, otherwise, returns null. When reservation
	 * fails, coherent state is restored automatically.
	 * 
	 * @param info
	 * @return
	 */
/* TODO
 * Unimplemented parameter type: eu.xtreemos.xosd.localallocmgr.frontend.Request
 */
int createReservation( char** returnValue);


	/**
	 * Updates a reservation with a request, but leaving the reservation id
	 * intact. Gets true, if all went well, false if it fails. The coherent
	 * state is restored automatically.
	 * 
	 * @param reservationID
	 * @param info
	 * @return
	 */
/* TODO
 * Unimplemented parameter type: eu.xtreemos.xosd.localallocmgr.frontend.Request
 */
int updateReservation(const char* __reservationID, char* returnValue);


	/**
	 * Creates a series of reservation updates. Note that if one fails, all
	 * other are nullified also and the state of all TimeTables is returned to
	 * the original state before the call.
	 * 
	 * @param requests
	 * @return
	 * @throws AttributeConformanceException
	 */

int updateReservations(const LinkedList __requests, char* returnValue);


	/**
	 * Removes all entries regarding a reservation id. Note, that here the only
	 * criteria is a reservation id and not the whole needed info, for example
	 * how much of the resource needs to be freed as well. Use this method
	 * wisely, otherwise, please use create/update reservation methods and use
	 * remove request.
	 * 
	 * @param reservationID
	 * @return
	 */

int releaseReservation(const char* __reservationID, char* returnValue);


	/**
	 * Returns all resources that are used by some reservation.
	 * 
	 * @param reservationID
	 * @return
	 */

int getReservationResources(const char* __reservationID, ArrayList* returnValue);


	/**
	 * Associates a job with a reservation id. This is only on a semantic level,
	 * and should be used whenever reservations are dependent.
	 * 
	 * @param jobID
	 * @param reservationID
	 * @return
	 */

int attachToJob(const char* __jobID,const char* __reservationID, char* returnValue);


	/**
	 * Removes connection between a job and reservation id. This is managed by
	 * the user/service and not automatically. Associations betweem reservations
	 * should be used whenever they are dependent.
	 * 
	 * @param jobID
	 * @param reservationID
	 * @return
	 */

int detachFromJob(const char* __jobID,const char* __reservationID, char* returnValue);




int removeJob(const char* __jobID, char* returnValue);


	/**
	 * Remove any info regarding a job. Managed by the user/service.
	 * 
	 * @param jobID
	 * @return
	 */

int reservationsForJob(const char* __jobID, ArrayList* returnValue);


	/**
	 * Returns all free slots in a timetable for some resource.
	 * 
	 * @param resourceID
	 * @return null if no such resource exists or there was error with attribute
	 *         conformance.
	 */

int getAllFreeSlotsFor(const char* __resourceID, FreeSlots* returnValue);


	/**
	 * Returns all free slots for a given time frame for a specific resource.
	 * 
	 * @param resourceID
	 * @param from
	 * @param to
	 * @return
	 */

int getFreeSlotsFor(const char* __resourceID,const GregorianCalendar __from,const GregorianCalendar __to, FreeSlots* returnValue);


	/**
	 * selects available from all elements (see
	 * {@link #selectAvailableDT(String, Integer, GregorianCalendar, GregorianCalendar)}
	 * description!)
	 * 
	 * @param resourceID
	 * @param amount
	 * @return
	 */
/* TODO
 * Unimplemented return type: java.util.ArrayList<eu.xtreemos.xosd.localallocmgr.basic.TTElm>
 */
int selectAvailable(const char* __resourceID,int __amount, void* returnValue);


	/**
	 * selects all already reserved elements within a timetable for some
	 * resource (identified by resourceID), where the amount of available
	 * resource property CurrentAmount is smaller than MaxAmount by more than
	 * given parameter "amount". Also, the sharing value of such element must
	 * not be EXCLUSIVE.
	 * 
	 * @param resourceID
	 * @param amount
	 * @param from
	 * @param to
	 * @return
	 */
/* TODO
 * Unimplemented return type: java.util.ArrayList<eu.xtreemos.xosd.localallocmgr.basic.TTElm>
 */
int selectAvailableDT(const char* __resourceID,int __amount,const GregorianCalendar __from,const GregorianCalendar __to, void* returnValue);


	/**
	 * In order to make a new resource available and manageable (the ones that
	 * are not initialized in the startup process), one needs to register them,
	 * so that the system prepares a timetable for the reservations.
	 * 
	 * @param id
	 * @return
	 */

int initializeResource(const char* __id, int* returnValue);


	/**
	 * returns all initialized resources
	 * 
	 * @return
	 */

int getInitializedResources( ArrayList* returnValue);


	/**
	 * creates a request for purging all elements that finish before the given
	 * date. Since it is of no value to the executor and job manager to have
	 * reservations before current real time, all past reservations can be
	 * removed without any loss of info.
	 * 
	 * @param date
	 * @return
	 */
/* TODO
 * Unimplemented return type: eu.xtreemos.xosd.localallocmgr.frontend.Request
 */
int createRequestsPurgeReservationsBefore(const GregorianCalendar __date, void* returnValue);


	/**
	 * dummy method that allows "on-hand" addition of properties. Should be
	 * replaced by proper initialization system ...
	 * 
	 * @param resID
	 * @param property
	 */
/* TODO
 * Unimplemented parameter type: interface eu.xtreemos.xosd.localallocmgr.frontend.properties.IResourceProperty
 */
int addResourceProperty(const char* __resID, int* returnValue);


	/**
	 * get all time table elements with selected attributes for a resource. The
	 * contraints are a map of attribute types and their values.
	 * 
	 * @param resID
	 * @param constraints
	 * @return
	 */
/* TODO
 * Unimplemented parameter type: java.util.Hashtable
 *//* TODO
 * Unimplemented return type: java.util.ArrayList<eu.xtreemos.xosd.localallocmgr.basic.TTElm>
 */
int getSelection(const char* __resID, void* returnValue);


	/**
	 * For a list of the IDs obtained from the
	 * {@link #createReservation(Request)}, the method builds a list of
	 * reservation slots descriptors, effectively returning the timetable
	 * entries usable for the reservations. Get required information for the
	 * ReservationManager about all reservations slots in the time table
	 * regarding some reservation id.
	 * 
	 * @param reservationIDs
	 *            A collection of the IDs obtained from
	 *            {@link #createReservation(Request)}.
	 * @return A collection of timetable entry descriptors.
	 */

int getReservationsInfo(const ArrayList __ids, LinkedList* returnValue);


	/**
	 * creates a massive a sequence of reservations. returns the ids of
	 * reservatins with a 1:1 mapping regarding their place. If one of the
	 * reservations fails, all of them must fail also. If reservation fails, but
	 * restoring succeeds, the empty array is returned, otherwise, if the
	 * restoring fails also, the null object is returned.
	 * 
	 * @param reservations
	 * @return
	 */
/* TODO
 * Unimplemented parameter type: java.util.ArrayList<eu.xtreemos.xosd.localallocmgr.frontend.Request>
 */
int createReservations( ArrayList* returnValue);


	/**
	 * restores the state of all timetables just before the creation of the
	 * given reservation. If it was already restored or if there is no info
	 * about it, the call fails otherwise, it succeeds.
	 * 
	 * @param reservationID
	 * @return
	 * @throws AttributeConformanceException
	 */

int restoreForCheckpointBefore(const ArrayList __reservationIDs, char* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
