#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * 
	 */

int createRequest(const char* __jsdlTable, ArrayListCA* returnValue);




int storeCoordinates(const CommunicationAddress __ca,const char* __x,const char* __y );




int pushMDinfo(const char* __Info, int* returnValue);




int retrieveMDinfo(const char* __Query, char** returnValue);


	/**
	 * Retrieve a collection of resources that match the job's resource demands.
	 * The resource query is expressed in a JSDL document with its contents in a
	 * string.
	 * 
	 * @param query
	 *            The contents of the XML file with JSDL query containing the
	 *            resource query as a part of a job description.
	 * @param userCtx
	 *            The certificate signifying the user on whose behalf the call
	 *            is doing the query.
	 * @param howMany
	 *            A hint, specifying how many retrieved resources we would like
	 *            to have.
	 * @return A collection of addresses of nodes that offer resources that
	 *         satisfy the job's resource requirements.
	 */

int getResources(const char* __query,const char* __userCtx,int __howMany, ArrayListCA* returnValue);




int getResourcesADS(const char* __query,const char* __userCtx,int __howMany, ArrayListCA* returnValue);


	/**
	 * Retrieve a collection of resources that match the job's resource demands.
	 * The resource query is expressed in a JSDL document with its contents in a
	 * string.
	 * 
	 * @param query
	 *            The contents of the XML file with JSDL query containing the
	 *            resource query as a part of a job description.
	 * @param userCtx
	 *            The certificate signifying the user on whose behalf the call
	 *            is doing the query.
	 * @param howMany
	 *            A hint, specifying how many retrieved resources we would like
	 *            to have.
	 * @return A collection of addresses of nodes that offer resources that
	 *         satisfy the job's resource requirements.
	 */

int getResourcesCentral(const char* __query,const char* __userCtx,int __howMany, ArrayListCA* returnValue);


	/**
	 * Retrieve a collection of resources that match the job's resource demands.
	 * The resource query is expressed in a JSDL document with its contents in a
	 * string.
	 * 
	 * @param query
	 *            The contents of the XML file with JSDL query containing the
	 *            resource query as a part of a job description.
	 * @return A collection of addresses of nodes that offer resources that
	 *         satisfy the job's resource requirements.
	 */

int getResourcesFromString(const char* __query, ArrayListCA* returnValue);


	/**
	 * Retrieve a collection of resources that match the job's resource demands.
	 * The resource query is expressed in a structure containing a parsed and
	 * searchable JSDL document.
	 * 
	 * @param jsdl
	 *            The structure containing the parsed and searchable contents of
	 *            the XML file with JSDL query.
	 * @return A collection of addresses of nodes that offer resources that
	 *         satisfy the job's resource requirements.
	 */

int getResourcesFromStructure(const char* __jsdl, ArrayListCA* returnValue);


	/**
	 * Retrieve a collection of resources that match the job's resource demands.
	 * The resource query is expressed in a JSDL document with its contents in a
	 * string. The resulting nodes will be sorted according to the attribute
	 * ordering.
	 * 
	 * @param query
	 *            The contents of the XML file with JSDL query containing the
	 *            resource query as a part of a job description.
	 * @param comparator
	 *            The comparator to use when sorting the records.
	 * @return A collection of addresses of nodes that offer resources that
	 *         satisfy the job's resource requirements.
	 */

int getResourcesSorted(const char* __query,const char* __comparator, ArrayListCA* returnValue);




int getResourcesScored(const char* __query, ArrayListCA* returnValue);




int getResourcesScoredWeighted(const char* __query,const char* __weights, ArrayListCA* returnValue);


	/**
	 * A proxy call to ResourceMonitor.query of a service running at particular
	 * node.
	 * 
	 * @param address
	 *            The node we request the resource details of the
	 *            ResourceMonitor service from.
	 * @return The GLUE structure enumerating the resources of the node.
	 */
/* TODO
 * Unimplemented return type: java.util.Hashtable<java.lang.String, java.lang.Object>
 */
int getNodeResourceGLUE(const CommunicationAddress __address, void* returnValue);


	/**
	 * A proxy call to ResourceMonitor.query of a service running at particular
	 * node.
	 * 
	 * @param address
	 *            The node we request the resource details of the
	 *            ResourceMonitor service from.
	 * @return The collection of resource descriptors detailing the resources of
	 *         the node.
	 */
/* TODO
 * Unimplemented return type: java.util.ArrayList<eu.xtreemos.xosd.resmng.data.ResourceDescriptorRecord>
 */
int getNodeResourceDescriptor(const CommunicationAddress __address, void* returnValue);


	/**
	 * A function for testing stuff.
	 * 
	 * @return Nothing in particular.
	 */

int testCall( ArrayListCA* returnValue);




int getResourcesFromParsedCommand(const char* __command, ArrayListCA* returnValue);


	/**
	 * Returns the monitoring information associated with the resource. Only the
	 * users authorised for access to the resource can obtain the information.
	 * 
	 * @param resource
	 *            The resource we are querying the information on.
	 * @param userCtx
	 *            The user that queries the information
	 * @return A list of metrics (see {@link #getResourceMetrics} and their
	 *         respective values on the resource.
	 * 
	 */
/* TODO
 * Unimplemented return type: java.util.Hashtable<java.lang.String, java.lang.String>
 */
int getResInfo(const CommunicationAddress __resource,const char* __userCtx, void* returnValue);


	/**
	 * Returns the list of metrics available on that resource. Only the users
	 * authorised for access to the resource can obtain the information.
	 * 
	 * @param resource
	 *            The resource we are querying the information on.
	 * @param userCtx
	 *            The user that queries the information
	 * @return A list of metrics monitored on the resource.
	 * 
	 */

int getResMetrics(const CommunicationAddress __resource,const char* __userCtx, ArrayList* returnValue);


	/**
	 * Retrieve the resource descriptors of the nodes from the given list. It
	 * asynchronously calls each node's resource monitor and queries its
	 * resource info. Once all the responses are accounted for, it returns the
	 * result.
	 * 
	 * @param resources
	 *            The list of communication addresses of the resources that we
	 *            would like to learn the resource properties of.
	 * @return The list of resource descriptors of the nodes that the local
	 *         resource monitors succeeded in sending the resource description.
	 *         <B>Warning:</B> the order of the resources in the returned value
	 *         will differ from the order of their respective addresses in the
	 *         call parameter. Please use
	 *         {@link ResourceDescriptorRecord#communicationAddress} of each
	 *         element to check the responses' address.
	 */
/* TODO
 * Unimplemented return type: java.util.ArrayList<eu.xtreemos.xosd.resmng.data.ResourceDescriptorRecord>
 */
int getResourceDescriptors(const ArrayListCA __resources, void* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
