#include "XATICATypes.h"
#ifdef __cplusplus
 extern "C" {
 #endif
	/**
	 * Transform an XML stored in a file into a hash table containing the
	 * searchable elements of the source XML. The elements of the hashtable are
	 * either strings for simple tags, instances of Hashtable for complex
	 * structures, and instances of ArrayList for multiple entries having the
	 * same key.
	 * @param path The path to the xml file on the file system of the service's
	 * host.
	 * @param schemaType The type of schema. (TODO use some sort of an enum
	 * type instead of int)
	 * @return A Hashtable containing the searchable elements of the source XML.
	 * @throws SAXException
	 * @throws IOException
	 */
/* TODO
 * Unimplemented return type: java.util.Hashtable<java.lang.String, java.lang.Object>
 */
int getXMLObject(const char* __path,int __schemaType, void* returnValue);


	/**
	 * Transform an XML stored in a DOM document into a hash table containing
	 * the searchable elements of the source XML. The elements of the hashtable
	 * are either strings for simple tags, instances of Hashtable for complex
	 * structures, and instances of ArrayList for multiple entries having the
	 * same key.
	 * @param xmlDocument xml document object
	 * @param schemaType The type of schema. (TODO use some sort of an enum
	 * type instead of int)
	 * @return A Hashtable containing the searchable elements of the source XML.
	 * @author eva.milosev@xlab.si
	 */
/* TODO
 * Unimplemented parameter type: interface org.w3c.dom.Document
 *//* TODO
 * Unimplemented return type: java.util.Hashtable<java.lang.String, java.lang.Object>
 */
int getXMLObjectFromDocument(int __schemaType, void* returnValue);


	/**
	 * Transform an XML stored in a string into a hash table containing the
	 * searchable elements of the source XML. The elements of the hashtable are
	 * either strings for simple tags, instances of Hashtable for complex
	 * structures, and instances of ArrayList for multiple entries having the
	 * same key.
	 *
	 * @param xmlDocument The contents of the XML contents.
	 * @param schemaType The type of schema. (TODO use some sort of an enum
	 * type instead of int)
	 * @return A Hashtable containing the searchable elements of the source XML.
	 */
/* TODO
 * Unimplemented return type: java.util.Hashtable<java.lang.String, java.lang.Object>
 */
int getXMLObjectFromString(const char* __xmlDocument,int __schemaType, void* returnValue);


#ifdef __cplusplus 
 } 
 #endif 
