/**
 * Copyright (c) 2008 Barcelona Supercomputing Center - Centro Nacional de
 * Supercomputación, Heinrich-Heine-Universität Düsseldorf, and XLAB d.o.o.
 * All rights reserved.
 *
 * This file is part of DIXI. DIXI is part of XtreemOS, a Linux-based Grid
 * Operating System, see <http://www.xtreemos.eu> for more details. The
 * XtreemOS project has been developed with the financial support of the
 * European Commission's IST program under contract #FP6-033576.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *     * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *     * Neither the name of the XtreemOS project nor the names of its
 *     partners and/or contributors may be used to endorse or promote
 *     products derived from this software without specific prior written
 *     permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * @author matej.artac@xlab.si
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef XOS_RESMNG_H
#define XOS_RESMNG_H
	
/*
	The following is a rough template for list of reservation
	requests in XML. Please note that the CommunicationAddress
	is not prepared properly.
	
<list><ReservationRequest>
  <nodeAddress>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </nodeAddress>
  <localRequest>
    <elmReqs>
      <eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
        <resourceID>CPU0</resourceID>
        <ttelm>
          <attributes>
            <attributes>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                    <owners>
                      <entry>
                        <string>test</string>
                        <string>Java unit test</string>
                      </entry>
                    </owners>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
                  <value class="gregorian-calendar">
                    <time>1243416826647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
                  <value class="gregorian-calendar">
                    <time>1243413226647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
                  <value class="int">100</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              </entry>
            </attributes>
          </attributes>
        </ttelm>
        <type>ADD</type>
      </eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
    </elmReqs>
  </localRequest>
</ReservationRequest>
<ReservationRequest>
  <nodeAddress>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </nodeAddress>
  <localRequest>
    <elmReqs>
      <eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
        <resourceID>CPU0</resourceID>
        <ttelm>
          <attributes>
            <attributes>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                    <owners>
                      <entry>
                        <string>test</string>
                        <string>Java unit test</string>
                      </entry>
                    </owners>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
                  <value class="gregorian-calendar">
                    <time>1243418626647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
                  <value class="gregorian-calendar">
                    <time>1243415026647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
                  <value class="int">100</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              </entry>
            </attributes>
          </attributes>
        </ttelm>
        <type>ADD</type>
      </eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
    </elmReqs>
  </localRequest>
</ReservationRequest>
<ReservationRequest>
  <nodeAddress>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </nodeAddress>
  <localRequest>
    <elmReqs>
      <eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
        <resourceID>CPU0</resourceID>
        <ttelm>
          <attributes>
            <attributes>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                    <owners>
                      <entry>
                        <string>test</string>
                        <string>Java unit test</string>
                      </entry>
                    </owners>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
                  <value class="gregorian-calendar">
                    <time>1243429426647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
                  <value class="gregorian-calendar">
                    <time>1243425826647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
                  <value class="int">100</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              </entry>
            </attributes>
          </attributes>
        </ttelm>
        <type>ADD</type>
      </eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
    </elmReqs>
  </localRequest>
</ReservationRequest>
<ReservationRequest>
  <nodeAddress>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </nodeAddress>
  <localRequest>
    <elmReqs>
      <eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
        <resourceID>CPU0</resourceID>
        <ttelm>
          <attributes>
            <attributes>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">EXCLUSIVE</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
                  <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                    <owners>
                      <entry>
                        <string>test</string>
                        <string>Java unit test</string>
                      </entry>
                    </owners>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
                  <value class="gregorian-calendar">
                    <time>1243424026647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
                  <value class="gregorian-calendar">
                    <time>1243420426647</time>
                    <timezone>Europe/Skopje</timezone>
                  </value>
                </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              </entry>
              <entry>
                <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
                <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
                  <value class="int">100</value>
                </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              </entry>
            </attributes>
          </attributes>
        </ttelm>
        <type>ADD</type>
      </eu.xtreemos.xosd.localallocmgr.frontend.utils.TTElmRequestAdd>
    </elmReqs>
  </localRequest>
</ReservationRequest>
</list>	
*/

enum request_type {
	XOS_ADD_REQUEST,
	XOS_DELAY_REQUEST,
	XOS_ECHO_REQUEST,
	XOS_REMOVE_REQUEST,
	XOS_REMOVE_OBJECT_REQUEST
};

enum slot_sharing_type {
	XOS_SHARING_MUTUAL,
	XOS_SHARING_EXCLUSIVE
};

struct ttelm_type {
	char* resourceID;
	slot_sharing_type sharingType;
	char* ownerInfoOwner;
	char* ownerInfoFullName;
	long startTime; // ms since 1.1.1970
	long endTime; // ms since 1.1.1970
	int amount;
};

typedef struct ttelm_type* TTElm;


struct elmReq {
	// this defines which class to use (e.g. 
	//   eu.xtreemos.xosd.locallalocmgr.frontend.utils.TTElmRequestAdd)
	request_type rqType; 
	struct ttelm_type ttelm;
};

typedef struct elmReq* ElmReq;

struct reservationRequest {
	CommunicationAddress nodeAddress;
	ElmReq request;
};

/*
	It should be similar with the UpdateRequest.
*/

struct updateRequest {
	CommunicationAddress nodeAddress;
	char* reservationID;
	ElmReq request;
};

/*
	The following is a rough template for list of free slots
	in XML.

<eu.xtreemos.xosd.localallocmgr.basic.manipulators.FreeSlots>
  <firstOccupied>
    <time>1243413226647</time>
    <timezone>Europe/Skopje</timezone>
  </firstOccupied>
  <lastOccupied>
    <time>1243429426647</time>
    <timezone>Europe/Skopje</timezone>
  </lastOccupied>
  <free>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243415026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243415026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243416826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243416826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243418626647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243420426647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243424026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243425826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
  </free>
</eu.xtreemos.xosd.localallocmgr.basic.manipulators.FreeSlots>

*/

struct freeSlots {
	long firstOccupied; // time in ms since 1.1.1970
	long lastOccupied; // time in ms since 1.1.1970
	int slotCount;
	TTElm[] slots; // 0...slotCount
};

typedef struct freeSlots* FreeSlots;

/*
	Reservation slots:

<list><eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
  <id>506f58ae-6da7-4bbc-9127-7435296fa673</id>
  <resourceID>CPU0</resourceID>
  <location>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </location>
  <info>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                <owners>
                  <entry>
                    <string>test</string>
                    <string>Java unit test</string>
                  </entry>
                  <entry>
                    <string>506f58ae-6da7-4bbc-9127-7435296fa673</string>
                    <string>ReservationID</string>
                  </entry>
                </owners>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              <value class="int">100</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243413226647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243415026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                <owners>
                  <entry>
                    <string>506f58ae-6da7-4bbc-9127-7435296fa673</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>81bcded8-edec-4d83-9ce9-fc86de38d7d3</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>test</string>
                    <string>Java unit test</string>
                  </entry>
                </owners>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              <value class="int">200</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243415026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243416826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
  </info>
  <constraints>
    <entry>
      <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
      <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
        <owners>
          <entry>
            <string>506f58ae-6da7-4bbc-9127-7435296fa673</string>
            <string>ReservationID</string>
          </entry>
        </owners>
      </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
    </entry>
  </constraints>
</eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
<eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
  <id>5ae12b54-699d-42f9-b002-d1347f9baef2</id>
  <resourceID>CPU0</resourceID>
  <location>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </location>
  <info>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                <owners>
                  <entry>
                    <string>5ae12b54-699d-42f9-b002-d1347f9baef2</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>test</string>
                    <string>Java unit test</string>
                  </entry>
                </owners>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">EXCLUSIVE</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              <value class="int">100</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243420426647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243424026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
  </info>
  <constraints>
    <entry>
      <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
      <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
        <owners>
          <entry>
            <string>5ae12b54-699d-42f9-b002-d1347f9baef2</string>
            <string>ReservationID</string>
          </entry>
        </owners>
      </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
    </entry>
  </constraints>
</eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
<eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
  <id>f79e2667-cd12-4622-991e-2e573faa282a</id>
  <resourceID>CPU0</resourceID>
  <location>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </location>
  <info>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                <owners>
                  <entry>
                    <string>f79e2667-cd12-4622-991e-2e573faa282a</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>test</string>
                    <string>Java unit test</string>
                  </entry>
                </owners>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              <value class="int">100</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243425826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243429426647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
  </info>
  <constraints>
    <entry>
      <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
      <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
        <owners>
          <entry>
            <string>f79e2667-cd12-4622-991e-2e573faa282a</string>
            <string>ReservationID</string>
          </entry>
        </owners>
      </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
    </entry>
  </constraints>
</eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
<eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
  <id>81bcded8-edec-4d83-9ce9-fc86de38d7d3</id>
  <resourceID>CPU0</resourceID>
  <location>
    <externalAddress class="java.net.Inet4Address" resolves-to="java.net.InetAddress">
      <hostName>172.16.117.196</hostName>
      <address>-1408207420</address>
      <family>2</family>
    </externalAddress>
    <host class="java.net.Inet4Address" reference="../externalAddress"/>
    <port>60000</port>
  </location>
  <info>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                <owners>
                  <entry>
                    <string>506f58ae-6da7-4bbc-9127-7435296fa673</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>81bcded8-edec-4d83-9ce9-fc86de38d7d3</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>test</string>
                    <string>Java unit test</string>
                  </entry>
                </owners>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              <value class="int">200</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243415026647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243416826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
    <eu.xtreemos.xosd.localallocmgr.basic.TTElm>
      <attributes>
        <attributes>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo">
                <owners>
                  <entry>
                    <string>81bcded8-edec-4d83-9ce9-fc86de38d7d3</string>
                    <string>ReservationID</string>
                  </entry>
                  <entry>
                    <string>test</string>
                    <string>Java unit test</string>
                  </entry>
                </owners>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.Sharing</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
              <value class="eu.xtreemos.xosd.localallocmgr.attributes.SharingValues">MUTUAL</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.Sharing>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
              <value class="int">100</value>
            </eu.xtreemos.xosd.localallocmgr.attributes.CurrentAmount>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.StartTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
              <value class="gregorian-calendar">
                <time>1243416826647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.StartTime>
          </entry>
          <entry>
            <java-class>eu.xtreemos.xosd.localallocmgr.attributes.EndTime</java-class>
            <eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
              <value class="gregorian-calendar">
                <time>1243418626647</time>
                <timezone>Europe/Skopje</timezone>
              </value>
            </eu.xtreemos.xosd.localallocmgr.attributes.EndTime>
          </entry>
        </attributes>
      </attributes>
    </eu.xtreemos.xosd.localallocmgr.basic.TTElm>
  </info>
  <constraints>
    <entry>
      <java-class>eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfoAttr</java-class>
      <eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
        <owners>
          <entry>
            <string>81bcded8-edec-4d83-9ce9-fc86de38d7d3</string>
            <string>ReservationID</string>
          </entry>
        </owners>
      </eu.xtreemos.xosd.localallocmgr.attributes.OwnersInfo>
    </entry>
  </constraints>
</eu.xtreemos.xosd.reservationmanager.base.ReservationSlot>
</list>

*/

struct reservationSlot {
	char* id;
	char* resourceID;
	CommunicationAddress location;
	int slotCount;
	TTElm[] slots; // 0...slotCount
	// we ignore the constraints section
};

typedef struct reservationSlot* ReservationSlot;

// serialisation and deserialisation

char* reservationRequests2XML(struct reservationRequest[] requests, int requestCount);

char* updateRequests2XML(struct updateRequest[] requests, int requestCount);

FreeSlots[] XML2FreeSlots(char* xml);

ReservationSlots[] XML2ReservationSlots(char* xml);



#endif
#ifdef __cplusplus
}
#endif
